

#include "mttask.h"

BOOL CMTThreadResources::IsKindOf(int nClass)
{
	return FALSE;
}

BOOL CMTThreadResources::FreeResources()
{
	return TRUE;
}

void CMTNotifTarget::OnThreadCountChange(int nThreadCount)
{
}

void CMTNotifTarget::OnTaskState(const LPCSTR* ppszStrings, int nStringCount, int nThread)
{
}

void CMTNotifTarget::OnLogEvent(LPCSTR pszMessage)
{
}

int CMTTask::Run(CMTThreadResources*& lpThreadRes, int nThreadNum, CMTNotifTarget* pnt)
{
	return 0;
}

int CMTTask::SafeInterrupt()
{
	return 0;
}

CMTTask* CMTTaskQueue::GetNextTask()
{
	return NULL;
}

CMTThreadArray::CMTThreadArray(CMTTaskQueue* pTaskQueue, CMTNotifTarget* pNotifTarget)
{
	m_hMutex = CreateMutex(NULL, FALSE, NULL);
	m_pTaskQueue = pTaskQueue;
	m_pNotifTarget = pNotifTarget;
	m_nThreads = m_nThreadsA = 0;
	m_pThreadHandles = (HANDLE*)malloc(0);
	m_ppTasks = (CMTTask**)malloc(0);
}

CMTThreadArray::~CMTThreadArray()
{
	CloseHandle(m_hMutex);
	free(m_pThreadHandles);
	free(m_ppTasks);
}

class CMTThread
{
public:
	CMTThread(CMTThreadArray* pAr, int nId);
	CMTThreadArray* m_pAr;
	int m_nId;
};

DWORD WINAPI MTThreadProc(LPVOID pvThread)
{
	CMTThread* pThread = (CMTThread*) pvThread;
	CMTTask* pTask;
	CMTThreadResources* pRsrc = NULL;
	//      ,  , 
	//    	
	while (pTask = pThread->m_pAr->GetNextTask(pThread->m_nId))
	{
		pTask->Run(pRsrc, pThread->m_nId, pThread->m_pAr->m_pNotifTarget);
		delete pTask;
	}
	if (pRsrc) {pRsrc->FreeResources(); delete pRsrc;}
	delete pThread;
	return 0;
}

void CMTThreadArray::SetNumThreads(int n, BOOL fInterruptTask, BOOL fWait)
{
	int i;
	DWORD dwTmpThreadId;

	WaitForSingleObject(m_hMutex, INFINITE);
	if (n > m_nThreads)
	{
		m_pThreadHandles = (HANDLE*)realloc(m_pThreadHandles, n*sizeof(HANDLE));
		m_ppTasks = (CMTTask**)realloc(m_ppTasks, n*sizeof(CMTTask*));
		for (int i = m_nThreads; i < n; i++) {m_pThreadHandles[i] = NULL; m_ppTasks[i] = NULL;}
		m_nThreads = n;
	}
	int nThreadsToRun = n - m_nThreadsA;

	if (nThreadsToRun > 0)
	{
		m_pNotifTarget->OnThreadCountChange(n);
		for (i = m_nThreadsA; i < n; i++)
		{
			if (m_pThreadHandles[i])
			{
				DWORD dwEC;
				if (GetExitCodeThread(m_pThreadHandles[i], &dwEC))
				{
					if (dwEC == STILL_ACTIVE) continue;
				}
			}
			m_pThreadHandles[i] = CreateThread(NULL, 0, MTThreadProc, new CMTThread(this, i), 0, &dwTmpThreadId);
		}
	}
	if (fInterruptTask && (nThreadsToRun < 0))
	{
		for (i = n; i < m_nThreadsA; i++)
		{
			if (m_ppTasks[i]) m_ppTasks[i]->SafeInterrupt();
		}
	}
	
	m_nThreadsA = n;
	ReleaseMutex(m_hMutex);

	if (fWait && (nThreadsToRun < 0)) 
		WaitForMultipleObjects(-nThreadsToRun, m_pThreadHandles+n, TRUE, INFINITE);

	if (nThreadsToRun < 0) m_pNotifTarget->OnThreadCountChange(n);
}

BOOL CMTThreadArray::IsExecuting()
{
	//    
	// Timeout = 0;  ,   .    ,
	//   
	return WaitForMultipleObjects(m_nThreads, m_pThreadHandles, TRUE, 0) == WAIT_TIMEOUT;
}

CMTTask* CMTThreadArray::GetNextTask(int nId)
{
	CMTTask* p;
	WaitForSingleObject(m_hMutex, INFINITE);
	if (nId < m_nThreadsA)
		p = m_pTaskQueue->GetNextTask(); else
		p = NULL;
	m_ppTasks[nId] = p;
	ReleaseMutex(m_hMutex);
	return p;
}

CMTThread::CMTThread(CMTThreadArray* pAr, int nId)
{
	m_pAr = pAr;
	m_nId = nId;
}