

#ifndef __MULTITHREAD_TASK__INCLUDED__
#define __MULTITHREAD_TASK__INCLUDED__

#include <windows.h>
#include <winbase.h>

class CMTThreadResources
{
public:
	virtual BOOL IsKindOf(int nClass);
	virtual BOOL FreeResources();
};

class CMTNotifTarget
{
public:
	virtual void OnThreadCountChange(int nThreadCount);
	virtual void OnTaskState(const LPCSTR* ppszStrings, int nStringCount, int nThread);
	virtual void OnLogEvent(LPCSTR pszMessage);
};

class CMTTask
{
public:
	virtual int Run(CMTThreadResources*& lpThreadRes, int nThreadNum, CMTNotifTarget* pnt);
	virtual int SafeInterrupt();
};

class CMTTaskQueue
{
public:
	virtual CMTTask* GetNextTask();
};

class CMTThreadArray
{
	friend DWORD WINAPI MTThreadProc(LPVOID pvThread);
public:
	CMTThreadArray(CMTTaskQueue* pTaskQueue, CMTNotifTarget* pNotifTarget);
	~CMTThreadArray();

	void			SetNumThreads(int n, BOOL fInterruptTask, BOOL fWait); //  
																  //  
	BOOL			IsExecuting(); // ,    -
	
private:
	CMTTask*		GetNextTask(int nId); //    
								   	   	  // nId -  

	CMTTaskQueue*	m_pTaskQueue;      //  
	CMTNotifTarget*	m_pNotifTarget;    //  ,     
	HANDLE*			m_pThreadHandles;  //   
	CMTTask**		m_ppTasks;         //  
	int				m_nThreads;        //    
	int				m_nThreadsA;       //   
	HANDLE			m_hMutex;
};

#endif // __MULTITHREAD_TASK__INCLUDED__