#include "ntdlg.h"

CNotifTargetDialog::CNotifTargetDialog(HWND hDlg, int nTaskLVID, int nLogLBID)
{
	m_hDlg = hDlg;
	m_nTaskLVID = nTaskLVID;
	m_nLogLBID = nLogLBID;
}

void CNotifTargetDialog::OnThreadCountChange(int nThreadCount)
{
	int nCurCount, i;
	LVITEM lvi;

	SendDlgItemMessage(m_hDlg, m_nTaskLVID, LVM_SETITEMCOUNT, nThreadCount, LVSICF_NOSCROLL);
	nCurCount = SendDlgItemMessage(m_hDlg, m_nTaskLVID, LVM_GETITEMCOUNT, 0, 0);

	if (nThreadCount > nCurCount)
	{
		for (i = nCurCount; i < nThreadCount; i++) 
		{
			lvi.mask = 0;
			lvi.iItem = i;
			lvi.iSubItem = 0;
			SendDlgItemMessage(m_hDlg, m_nTaskLVID, LVM_INSERTITEM, 0, (LPARAM)&lvi);
		}
	}
	if (nThreadCount < nCurCount)
	{
		for (i = nCurCount - 1; i >= nThreadCount; i--)
		{
			SendDlgItemMessage(m_hDlg, m_nTaskLVID, LVM_DELETEITEM, i, 0);
		}
	}
}

void CNotifTargetDialog::OnTaskState(const LPCSTR* ppszStrings, int nStringCount, int nThread)
{
	LVITEM lvi;
	for (int i = 0; i < nStringCount; i++)
	{
		lvi.mask = LVIF_TEXT;
		lvi.pszText = const_cast<LPSTR>(ppszStrings[i]);
		lvi.iItem = nThread;
		lvi.iSubItem = i;
		SendDlgItemMessage(m_hDlg, m_nTaskLVID, LVM_SETITEMTEXT, nThread, (LPARAM)&lvi);
	}
}

void CNotifTargetDialog::OnLogEvent(LPCSTR pszMessage)
{
	SendDlgItemMessage(m_hDlg, m_nLogLBID, LB_INSERTSTRING, -1, (LPARAM)pszMessage);
}