
#include "scantask.h"
#include "ntdlg.h"
#include "resource.h"

int CALLBACK ScannerDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);
int CALLBACK AboutDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);

CScanTaskQueue* pq;
CNotifTargetDialog* pn;
CMTThreadArray* pa;
HINSTANCE hInst;

int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{	
	INITCOMMONCONTROLSEX iccex;
	WSADATA wsadata;

	hInst = hInstance;

	iccex.dwSize = sizeof(iccex);
	iccex.dwICC = ICC_INTERNET_CLASSES;
	InitCommonControlsEx(&iccex);
	WSAStartup(MAKEWORD(2,2), &wsadata);
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_SCANNER), NULL, ScannerDlgProc);
	WSACleanup();
	return 0;
}

int InsertColumn(HWND hDlg, int nID, int nSubitem, LPCSTR pszText, int nWidth)
{
	LVCOLUMN clmn;
	clmn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	clmn.fmt = LVCFMT_LEFT;
	clmn.cx = nWidth;
	clmn.iSubItem = nSubitem;
	clmn.pszText = const_cast<LPSTR>(pszText);
	return SendDlgItemMessage(hDlg, nID, LVM_INSERTCOLUMN, nSubitem, (LPARAM)&clmn);
}

LPTSTR CrackStr(LPTSTR str, LPTSTR delim)
{
	LPTSTR pstr = strstr(str, delim);
	if (pstr)
	{
		pstr[0] = 0;
		return pstr + strlen(delim);
	} else return NULL;
}


int CALLBACK ScannerDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	unsigned long ip_first, ip_last;
	char szports[512];
	int nports;
	unsigned short ports[256];
	LPSTR str1, str2;
	int nThreads;

	switch(Msg)
	{
	case WM_INITDIALOG:
		pa = NULL;

		InsertColumn(hDlg, IDC_THREADS, 0, "Action", 80);
		InsertColumn(hDlg, IDC_THREADS, 1, "IP", 90);
		InsertColumn(hDlg, IDC_THREADS, 2, "Port", 50);

		SetTimer(hDlg, 1, 100, NULL);

		return -1;

	case WM_TIMER:
		if (pa)
		{
			if (!pa->IsExecuting()) goto stop;
		}
		break;

	case WM_COMMAND:
		switch (wParam)
		{
		case IDOK:
			if (!pa)
			{
				EnableWindow(GetDlgItem(hDlg, IDC_IP1), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_IP2), FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_PORTS), FALSE);

				GetDlgItemText(hDlg, IDC_PORTS, szports, 512);
				SendDlgItemMessage(hDlg, IDC_IP1, IPM_GETADDRESS, 0, (LPARAM)&ip_first);
				SendDlgItemMessage(hDlg, IDC_IP2, IPM_GETADDRESS, 0, (LPARAM)&ip_last);
				
				str1 = szports;
				nports = 0;
				do
				{
					str2 = CrackStr(str1, ",");
					ports[nports++] = atoi(str1);
				} while (str1 = str2);

				pq = new CScanTaskQueue(ip_first, ip_last, ports, nports);
				pn = new CNotifTargetDialog(hDlg, IDC_THREADS, IDC_LOG);
				pa = new CMTThreadArray(pq, pn);
			}

			nThreads = GetDlgItemInt(hDlg, IDC_NTHREADS, NULL, FALSE);

			pa->SetNumThreads(nThreads, FALSE, FALSE);

			break;
		case IDCANCEL:
			if (pa)
			{
				pa->SetNumThreads(0, TRUE, TRUE);
				delete pa;
				delete pq;
				delete pn;
				pa = NULL;
			}
			EndDialog(hDlg, 0);
			break;

		case IDC_STOP:
			if (pa)
			{
				pa->SetNumThreads(0, TRUE, TRUE);

stop:
				delete pa;
				delete pq;
				delete pn;
				pa = NULL;

				EnableWindow(GetDlgItem(hDlg, IDC_IP1), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_IP2), TRUE);
				EnableWindow(GetDlgItem(hDlg, IDC_PORTS), TRUE);
			}
			break;

		case IDC_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTDLG), hDlg, AboutDlgProc);
			break;
		}
		break;
	}
	return 0;
}

int CALLBACK AboutDlgProc(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch(Msg)
	{
	case WM_COMMAND:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}
