
#include "scantask.h"
#include <stdio.h>

BOOL CScannerSocket::IsKindOf(int nClass)
{
	return nClass == 1;
}

BOOL CScannerSocket::FreeResources()
{
	return TRUE;
}

CScanTaskQueue::CScanTaskQueue(unsigned long ip_first, unsigned long ip_last, 
		const unsigned short* pports, int nports)
{
	m_ip_first = m_ip_cur = ip_first;
	m_ip_last = ip_last;
	m_pports = new unsigned short [nports];
	memcpy(m_pports, pports, nports * sizeof(unsigned short));
	m_nports = nports;
	m_nport_cur = -1;
}

CScanTaskQueue::~CScanTaskQueue()
{
	delete[] m_pports;
}


CMTTask* CScanTaskQueue::GetNextTask()
{
	unsigned long netmask;

	if (++m_nport_cur >= m_nports) //   
	{
		do
		{
			if (++m_ip_cur > m_ip_last) return NULL; //   

			//      
			if (m_ip_cur & 0x80000000)
			{
				if (m_ip_cur & 0x40000000)
				{
					if (m_ip_cur & 0x20000000)
						netmask = 0; else //   -   
						netmask = 0x000000FE;    //  C
				} else netmask = 0x0000FFFE; //  B
			} else netmask = 0x00FFFFFE; //  A
		} while (((m_ip_cur + 1) & netmask) == 0);
		m_nport_cur = 0;			
	}
	return new CScanTask(m_ip_cur, m_pports[m_nport_cur]);
}

CScanTask::CScanTask(unsigned long ip, unsigned short port)
{
	m_ip = ip;
	m_port = port;
}

int CScanTask::Run(CMTThreadResources*& lpThreadRes, int nThreadNum, CMTNotifTarget* pnt)
{
	char szport[6];
	char szlog[100];
	LPCSTR ppsz[3];
	
	if (lpThreadRes)
	{
		if (!lpThreadRes->IsKindOf(1)) 
		{
			lpThreadRes->FreeResources();
			delete lpThreadRes;
			lpThreadRes = new CScannerSocket;
		}
	} else lpThreadRes = new CScannerSocket;

	CScannerSocket* s = (CScannerSocket*) lpThreadRes;

	s->m_socket = socket(AF_INET, SOCK_STREAM, 0); //  
	SOCKADDR_IN addr;	
	memset(&addr, 0, sizeof(addr));
	addr.sin_family = AF_INET;		//   SOCKADDR_IN
	addr.sin_addr.S_un.S_addr = htonl(m_ip);
	addr.sin_port = htons(m_port);

	ppsz[0] = "Scanning";		//    
	ppsz[1] = inet_ntoa(addr.sin_addr);
	ppsz[2] = _itoa(m_port, szport, 10);
	pnt->OnTaskState(ppsz, 3, nThreadNum);	// ,  

	//  
	if (connect(s->m_socket, (SOCKADDR*)&addr, sizeof(addr)) == 0)
	{
		// 

		// TODO:   ,      
		// ,      .     

		//    
		sprintf(szlog, "Open port %s:%d", inet_ntoa(addr.sin_addr), m_port);
		pnt->OnLogEvent(szlog);
	}
	closesocket(s->m_socket); //  

	ppsz[0] = "Complete"; //    
	ppsz[1] = inet_ntoa(addr.sin_addr);
	ppsz[2] = _itoa(m_port, szport, 10);
	pnt->OnTaskState(ppsz, 3, nThreadNum); // 
	
	return 0;
}

int CScanTask::SafeInterrupt()
{
	return 0;
}