#ifndef __SCAN_TASK_INCLUDED__
#define __SCAN_TASK_INCLUDED__

#include <winsock2.h>
#include "mttask.h"

class CScannerSocket : public CMTThreadResources
{
public:
	virtual BOOL IsKindOf(int nClass);
	virtual BOOL FreeResources();

	SOCKET m_socket;
};

class CScanTaskQueue : public CMTTaskQueue
{
public:
	CScanTaskQueue(unsigned long ip_first, unsigned long ip_last, 
		const unsigned short* pports, int nports);
	~CScanTaskQueue();

	virtual CMTTask* GetNextTask();

	unsigned long m_ip_first, m_ip_last, m_ip_cur;
	unsigned short* m_pports;
	int m_nports, m_nport_cur;
};

class CScanTask : public CMTTask
{
public:
	CScanTask(unsigned long ip, unsigned short port);

	virtual int Run(CMTThreadResources*& lpThreadRes, int nThreadNum, CMTNotifTarget* pnt);
	virtual int SafeInterrupt();

	unsigned long m_ip;
	unsigned short m_port;
};


#endif // __SCAN_TASK_INCLUDED__